#include <qwidget.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qapp.h>
#include <qtimer.h>

typedef struct PlotPoint
{
    float x;
    float y;
} PlotPoint;

class LogPlot : public QWidget
{
    Q_OBJECT
 
 public:
    LogPlot(QWidget *parent=0, const char *name=0);
    ~LogPlot();
    void StartTimer(int time);
    void StopTimer();
    void ContinueTimer();
    void SetLimits(double min_x,double max_x,double min_y,double max_y);
    void SetParameters(char color_mode, char *unit_x,
		       char *unit_y, char *title);
    void UpdatePlot();
    void SetPoint(int index,float x,float y);
    void AllocPoints(int count);
    void FreePoints();
    PlotPoint *points;

 protected:
    void paintEvent( QPaintEvent * );

 private:
    double Min_x;
    double Max_x;
    double Min_y;
    double Max_y;
    char *Unit_x;
    char *Unit_y;
    char *Title;
    const int pos_x=40;
    const int pos_y=30;
    char Color_mode;
    QColor *drawcolor;
    QColor *gridcolor;
    int pointcount;
    QPixmap pixmap;
    QPainter paint;
    QTimer *timer;
    int timer_interval;
    
 private slots:
    void timeout();
};

#define CHART_LOOK_NORMAL 0
#define CHART_LOOK_REVERSE 1
#define CHART_LOOK_SCOPE 2
